//
//  plateau.c
//  TESTSDL
//
//  Created by anthony porte on 24/01/13.
//  Copyright (c) 2013 anthony porte. All rights reserved.
//

#include <stdio.h>
#include <stdio.h>
#include "SDL/SDL.h"
#include "plateau.h"

void initialiserPlateau(Plateau * pt_plateau){
    printf("        Debut initialiserPlateau\n");
    FILE * f = (fopen("/Users/ANTHONY/Desktop/SDL/TESTSDL/TESTSDL/coucou.txt"/*argv[1]*/,"r"));
    chargerPlateau (f, pt_plateau);
    printf("        Fin initialiserPlateau\n");
}

void chargerPlateau (FILE * f, Plateau * pt_plateau){
    printf("            Debut chargerPlateau\n");
	if(f != NULL){
		int i,j,lg=0, ht=0;
        char temp;
		fscanf(f,"%d %d\n", &lg, &ht);
        pt_plateau->largeur=lg;
        pt_plateau->hauteur=ht;
		printf("Largeur : %d, Hauteur : %d\n",pt_plateau->largeur,pt_plateau->hauteur);
		printf("AdresseLargeur : %p, adresseHauteur : %p\n",&(pt_plateau->largeur),&(pt_plateau->hauteur));
        
        /***** Allocation dynamique du tableau *****/
        pt_plateau->plateau = malloc(pt_plateau->largeur * sizeof(Zone*));
        if(pt_plateau->plateau == NULL)
            exit(EXIT_FAILURE);
        for(i = 0; i < pt_plateau->largeur; i++)
        {
            pt_plateau->plateau[i] = (Zone *)malloc(pt_plateau->hauteur * sizeof(Zone));
            if(pt_plateau->plateau[i] == NULL)
                exit(EXIT_FAILURE);
        }
        
		for(i=0;i<pt_plateau->hauteur;i++){
			j=0;
            while(j<pt_plateau->largeur){
                temp = fgetc(f);
                if (temp != '\n' && temp != '\r' && temp != '\t'){
                    switch (temp) {
                        case 'M':
                            pt_plateau->plateau[i][j].x = i;
                            pt_plateau->plateau[i][j].y = j;
                            pt_plateau->plateau[i][j].type = MUR_IND;
                            pt_plateau->plateau[i][j].accessible = false;
                            break;
                        case 'S':
                            pt_plateau->plateau[i][j].x = i;
                            pt_plateau->plateau[i][j].y = j;
                            pt_plateau->plateau[i][j].type = SPWAN;
                            pt_plateau->plateau[i][j].accessible = true;
                            break;
                        case 'C':
                            pt_plateau->plateau[i][j].x = i;
                            pt_plateau->plateau[i][j].y = j;
                            pt_plateau->plateau[i][j].type = MUR;
                            pt_plateau->plateau[i][j].accessible = false;
                            break;
                        case '.':
                            pt_plateau->plateau[i][j].x = i;
                            pt_plateau->plateau[i][j].y = j;
                            pt_plateau->plateau[i][j].type = VIDE;
                            pt_plateau->plateau[i][j].accessible = true;
                            break;
                        default:
                            break;
                    }
                    j++;
                }
			}
		}
		fclose(f);
	}
    printf("Largeur : %d, Hauteur : %d\n",pt_plateau->largeur,pt_plateau->hauteur);
    printf("AdresseLargeur : %p, adresseHauteur : %p\n",&(pt_plateau->largeur),&(pt_plateau->hauteur));
    printf("            Fin chargerPlateau\n");
    
}

void affichagePlateauConsole (Plateau * pt_plateau){
    printf("affichage plateau console begin\n");
    int i=0, j=0;
    printf("AdressePlateau : %p\n",pt_plateau);
    printf("Largeur : %d, Hauteur : %d\n",pt_plateau->largeur,pt_plateau->hauteur);
    printf("AdresseLargeur : %p, adresseHauteur : %p\n",&(pt_plateau->largeur),&(pt_plateau->hauteur));
    
    for(;i<8;i++){
        for(j=0;j<8;j++){
            switch (pt_plateau->plateau[i][j].type) {
                case MUR_IND:
                    printf("M");
                    break;
                case SPWAN:
                    printf("S");
                    break;
                case MUR:
                    printf("C");
                    break;
                case VIDE:
                    printf(".");
                    break;
                default:
                    printf("/");
                    break;
            }
        }
        printf("\n");
    }
    printf("affichage plateau console end\n");
}

void sauvegarderPlateau(FILE * f, Plateau * pt_plateau){
    fprintf(f, "%d ",pt_plateau->largeur);
    fprintf(f, "%d\n",pt_plateau->hauteur);
    int i, j;
    
    for(i=0;i<pt_plateau->hauteur;i++){
        for(j=0;j<pt_plateau->largeur;j++){
            pt_plateau->plateau[i][j].type = MUR_IND;
        }
    }
    
    for(i=0;i<pt_plateau->hauteur;i++){
        for(j=0;j<pt_plateau->largeur;j++){
            switch (pt_plateau->plateau[i][j].type) {
                case MUR_IND:
                    fprintf(f,"M");
                    break;
                case SPWAN:
                    fprintf(f,"S");
                    break;
                case MUR:
                    fprintf(f,"C");
                    break;
                case VIDE:
                    fprintf(f,".");
                    break;
                default:
                    break;
            }
        }
        fprintf(f,"\n");
    }
    fclose(f);
}
